#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=Icon\Icon.ico
#AutoIt3Wrapper_UseX64=n
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         M. Wagner
 Date:           10. August 2018

 Script Function:
	Converts wav or mp3 files from 440 Hz to 432 Hz.


MIT-Lizenz

English

Copyright (c) 2018 Michael Wagner

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE.


Deutsch

Copyright (c) 2018 Michael Wagner

Hiermit wird unentgeltlich jeder Person, die eine Kopie der Software und der zugehrigen Dokumentationen (die "Software") erhlt, die Erlaubnis
erteilt, sie uneingeschrnkt zu nutzen, inklusive und ohne Ausnahme mit dem Recht, sie zu verwenden, zu kopieren, zu verndern, zusammenzufgen, zu
verffentlichen, zu verbreiten, zu unterlizenzieren und/oder zu verkaufen, und Personen, denen diese Software berlassen wird, diese Rechte zu
verschaffen, unter den folgenden Bedingungen:

Der obige Urheberrechtsvermerk und dieser Erlaubnisvermerk sind in allen Kopien oder Teilkopien der Software beizulegen.

DIE SOFTWARE WIRD OHNE JEDE AUSDRCKLICHE ODER IMPLIZIERTE GARANTIE BEREITGESTELLT, EINSCHLIESSLICH DER GARANTIE ZUR BENUTZUNG FR DEN VORGESEHENEN
ODER EINEM BESTIMMTEN ZWECK SOWIE JEGLICHER RECHTSVERLETZUNG, JEDOCH NICHT DARAUF BESCHRNKT. IN KEINEM FALL SIND DIE AUTOREN ODER COPYRIGHTINHABER
FR JEGLICHEN SCHADEN ODER SONSTIGE ANSPRCHE HAFTBAR ZU MACHEN, OB INFOLGE DER ERFLLUNG EINES VERTRAGES, EINES DELIKTES ODER ANDERS IM
ZUSAMMENHANG MIT DER SOFTWARE ODER SONSTIGER VERWENDUNG DER SOFTWARE ENTSTANDEN.

#ce ----------------------------------------------------------------------------


Global $bulid = 38
Global $trace = 0
Global $tracedir
Global $sum = 0
Global $sumd = 0
Global $open
Global $endkey = "`Esc`"
Global $path[1]
Global $lang

trace()

$delay = IniRead(StringLeft(@ScriptName,StringLen(@ScriptName)-3) & "ini", "Global", "delay", "0")
AutoItSetOption ( "SendKeyDelay" , $delay )
AutoItSetOption ( "SendKeyDownDelay" , $delay )
ProcessSetPriority (StringLeft(@ScriptName,StringLen(@ScriptName)-3) & "exe", 4)
If FileExists(@TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-4) & " check.log") = 1 Then FileDelete(@TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-4) & " check.log")


;Is the language form windows german?
$lang = RegRead("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Nls\Language", "InstallLanguage")
;$lang = "Nix deutsch haben!"
logit('HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Nls\Language, InstallLanguage = ' & $lang)



;set prerequisite
DirCreate(@AppDataDir & "\Audacity")
DirCreate(@AppDataDir & "\Audacity\Chains")
IniWrite(@AppDataDir & "\Audacity\audacity.cfg", "GUI", "ShowSplashScreen", "0")
IniWrite(@AppDataDir & "\Audacity\audacity.cfg", "VST", "Rescan", "0")
IniWrite(@AppDataDir & "\Audacity\audacity.cfg", "FFmpeg", "Enabled", "0")
IniWrite(@AppDataDir & "\Audacity\audacity.cfg", "Export", "Format", "MP3")
;Delete hotkey Alt+G and Alt+F
IniWrite(@AppDataDir & "\Audacity\audacity.cfg", "NewKeys", "Tonhöhe\ ändern...", "Alt+D")
$var = IniReadSection(@AppDataDir & "\Audacity\audacity.cfg", "NewKeys")
If @error Then
    MsgBox(16, "Error", "Could not check the keyboard shortcuts in file '" & @AppDataDir & "\Audacity\audacity.cfg'.")
Else
    For $i = 1 To $var[0][0]
		If $var[$i][1] = "Alt+F" Then IniDelete(@AppDataDir & "\Audacity\audacity.cfg", "NewKeys", $var[$i][0])
		If $var[$i][1] = "Alt+G" Then IniDelete(@AppDataDir & "\Audacity\audacity.cfg", "NewKeys", $var[$i][0])
    Next
EndIf
;Set hotkey Alt+D and Alt+F
IniWrite(@AppDataDir & "\Audacity\audacity.cfg", "NewKeys", "Tonhöhe\ ändern...", "Alt+G")
IniWrite(@AppDataDir & "\Audacity\audacity.cfg", "NewKeys", "Change\ Pitch...", "Alt+G")
IniWrite(@AppDataDir & "\Audacity\audacity.cfg", "NewKeys", "ExportMp3", "Alt+F")
;Set Locale
logit(@AppDataDir & "\Audacity\audacity.cfg,Locale,Language = " & IniRead(@AppDataDir & "\Audacity\audacity.cfg", "Locale", "Language", ""))
If IniRead(@AppDataDir & "\Audacity\audacity.cfg", "Locale", "Language", "") <> "en" And IniRead(@AppDataDir & "\Audacity\audacity.cfg", "Locale", "Language", "") <> "de" Then
	If $lang = "0407" Then
		logit('Set language to de')
		IniWrite(@AppDataDir & "\Audacity\audacity.cfg", "Locale", "Language", "de")
	Else
		logit('Set language to en')
		IniWrite(@AppDataDir & "\Audacity\audacity.cfg", "Locale", "Language", "en")
	EndIf
EndIf
If IniRead(@AppDataDir & "\Audacity\audacity.cfg", "Locale", "Language", "") = "en" Then
	logit('Force set language to en')
	$lang = "en"
EndIf
If IniRead(@AppDataDir & "\Audacity\audacity.cfg", "Locale", "Language", "") = "de" Then
	logit('Force set language to de')
	$lang = "0407"
EndIf
If $lang = "0407" Then
	FileDelete(@AppDataDir & "\Audacity\Chains\Konvert 440 Hz to 432 Hz.txt")
	FileWriteLine(@AppDataDir & "\Audacity\Chains\Konvert 440 Hz to 432 Hz.txt", "ChangePitch: Percentage=-1,818100")
	FileWriteLine(@AppDataDir & "\Audacity\Chains\Konvert 440 Hz to 432 Hz.txt", "Normalize: ApplyGain=yes RemoveDcOffset=yes Level=-1,000000 StereoIndependent=yes")
	FileWriteLine(@AppDataDir & "\Audacity\Chains\Konvert 440 Hz to 432 Hz.txt", "ExportMp3:")
	FileWriteLine(@AppDataDir & "\Audacity\Chains\Konvert 440 Hz to 432 Hz.txt", "")
	FileDelete(@AppDataDir & "\Audacity\Chains\Normalisieren.txt")
	FileWriteLine(@AppDataDir & "\Audacity\Chains\Normalisieren.txt", "Normalize: ApplyGain=yes RemoveDcOffset=yes Level=-1,000000 StereoIndependent=yes")
	FileWriteLine(@AppDataDir & "\Audacity\Chains\Normalisieren.txt", "")
	If WinExists("ConvertSoundTo432Hz" & @UserName) Then
		MsgBox(16,StringLeft(@ScriptName,StringLen(@ScriptName)-4),StringLeft(@ScriptName,StringLen(@ScriptName)-4) & " kann nur einmal gleichzeitig gestartet werden!" & @CRLF & "Durch drcken der Taste " & $endkey & " kann es beendet werden.")
		Exit
	EndIf
Else
	FileDelete(@AppDataDir & "\Audacity\Chains\Convert 440 Hz to 432 Hz.txt")
	FileWriteLine(@AppDataDir & "\Audacity\Chains\Convert 440 Hz to 432 Hz.txt", "ChangePitch: Percentage=-1,818100")
	FileWriteLine(@AppDataDir & "\Audacity\Chains\Convert 440 Hz to 432 Hz.txt", "Normalize: ApplyGain=yes RemoveDcOffset=yes Level=-1,000000 StereoIndependent=yes")
	FileWriteLine(@AppDataDir & "\Audacity\Chains\Convert 440 Hz to 432 Hz.txt", "ExportMp3:")
	FileWriteLine(@AppDataDir & "\Audacity\Chains\Convert 440 Hz to 432 Hz.txt", "")
	FileDelete(@AppDataDir & "\Audacity\Chains\Normalize.txt")
	FileWriteLine(@AppDataDir & "\Audacity\Chains\Normalize.txt", "Normalize: ApplyGain=yes RemoveDcOffset=yes Level=-1,000000 StereoIndependent=yes")
	FileWriteLine(@AppDataDir & "\Audacity\Chains\Normalize.txt", "")
	If WinExists("ConvertSoundTo432Hz" & @UserName) Then
		MsgBox(16,StringLeft(@ScriptName,StringLen(@ScriptName)-4),StringLeft(@ScriptName,StringLen(@ScriptName)-4) & " can only be started once!" & @CRLF & "You can stop it by pressing " & $endkey)
		Exit
	EndIf
EndIf
GUICreate("ConvertSoundTo432Hz" & @UserName)



#include <Array.au3>



;Hint, get directory and set hotkey for exit
If $trace <> 1 Or FileExists($tracedir) = 0 Then
	If $lang = "0407" Then
		$ask=MsgBox (49, StringLeft(@ScriptName,StringLen(@ScriptName)-4),"Dieses Skript konvertiert wav oder mp3 Dateien von 440 Hz nach 432 Hz." & @CRLF & @CRLF & "ACHTUNG - Die originalen Dateien werden hierbei gelscht!" & @CRLF & @CRLF & "Sind Sie sicher, das Sie das mchten?")
	Else
		$ask=MsgBox (49, StringLeft(@ScriptName,StringLen(@ScriptName)-4),"This script converts wav or mp3 files from 440 Hz to 432 Hz." & @CRLF & @CRLF & "ATTENTION - The original files will be deleted!" & @CRLF & @CRLF & "Are you sure you want to do this?")
	EndIf
	If $ask <> 1 Then Exit


	If $lang = "0407" Then
		_ArrayAdd($path, FileSelectFolder("Bitte das Verzeichnis mit den zu konvertierenden Dateien angeben.","","C:\"))
		If _ArrayMax ($path) = "" Then
			logit("Es wurde kein Verzeichnis zum bearbeiten angegeben.")
			Exit
		EndIf
	Else
		_ArrayAdd($path, FileSelectFolder("Please enter the directory with the files to be converted.","","C:\"))
		If _ArrayMax ($path) = "" Then
			logit("No directory was specified for processing.")
			Exit
		EndIf
	EndIf


	If $lang = "0407" Then
		MsgBox (0, StringLeft(@ScriptName,StringLen(@ScriptName)-4),"Das Konvertieren startet in 20 Sekunden." & @CRLF & @CRLF & "BITTE WREND DAS SKRIPT LUFT MAUS UND TASTATUR NICHT VERWENDEN." & @CRLF & @CRLF & "Zum unterbrechen des Prozesses Taste " & $endkey & " drcken.",20)
	Else
		MsgBox (0, StringLeft(@ScriptName,StringLen(@ScriptName)-4),"The conversion starts in 20 seconds." & @CRLF & @CRLF & StringUpper("Please do not use mouse and keyboard while the script is running.") & @CRLF & @CRLF & "To abort the process, simply press the " & $endkey & " key.",20)
	EndIf
EndIf

; Delete Log-File, if older 1 Day
If FileExists(@TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-3) & "log") Then
	$file = FileOpen(@TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-3) & "log", 0)
	If $file = -1 Then
		MsgBox(16, "Error", "Coudn't open File '" & @TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-3) & "log'.")
		Exit
	EndIf
	$line = FileReadLine($file)
	FileClose($file)
	If StringMid ( $line, 9, 2 ) <> @MDAY Then
		FileDelete(@TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-3) & "log")
	EndIf
EndIf

logit("build = " & $bulid)
logit("Trace = " & $trace)
logit("delay = " & $delay)
logit("$tracedir = " & $tracedir)

If $trace > 0 Then
	If $tracedir <> "" Then
		_ArrayAdd($path, $tracedir)
	EndIf
	HotKeySet("{PAUSE}","end")
	If @Compiled = 1 Then
		ShellExecute(StringLeft(@ScriptName,StringLen(@ScriptName)-3) & "log", "", @TempDir)
	EndIf
Else
	HotKeySet("{Esc}","end")
EndIf



While _ArrayMax ($path) <> ""
	$open = _ArrayMaxIndex ($path)
	checkdir($path[1])
	_ArrayDelete ($path, 1)
WEnd

If $lang = "0407" Then
	logit("Fertig! - " & $sum & " Dateien wurden konvertiert.")
	If FileExists(@TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-4) & " check.log") = 1 Then Run('notepad.exe "' & @TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-4) & ' check.log"', @WorkingDir)
	Sleep($delay*100)
	MsgBox (0, StringLeft(@ScriptName,StringLen(@ScriptName)-4),"Die Konvertierung nach 432 Hz wurde durchgefhrt." & @CR & @CR  & $sumd & " Verzeichnise wurden durchsucht. "& $sum & " Dateien wurden berprft / konvertiert.")
Else
	If FileExists(@TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-4) & " check.log") = 1 Then Run('notepad.exe "' & @TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-4) & ' check.log"', @WorkingDir)
	logit("Finish! - " & $sum & " files have been converted.")
	Sleep($delay*100)
	MsgBox (0, StringLeft(@ScriptName,StringLen(@ScriptName)-4),"The conversion to 432 Hz is completed." & @CR & @CR & $sumd & " directorys have been scanned, " & $sum & " files have been checked / converted.")
EndIf








Func checkdir ($checkdir)
	If StringInStr($checkdir, "#") <> 0 Or StringInStr($checkdir, "!") <> 0 Then
		If $lang = "0407" Then
			$text = "Verzeichnis/File " & Chr(13) & $checkdir & Chr(13) & " enthlt ein nicht untersttztes Zeichen." & Chr(13) & Chr(13) & "Bitte sicherstellen, das kein `#` oder `!` darin vorkommt."
		Else
			$text = "Directory/File " & Chr(13) & $checkdir & Chr(13) & " contains an unsupported character." & Chr(13) & Chr(13) & "Please make sure that there is no `#` or `!` in it."
		EndIf
		logit("Error - " & $text)
		MsgBox(16, StringLeft(@ScriptName,StringLen(@ScriptName)-4), $text)
		Exit
	EndIf
	$search = FileFindFirstFile($checkdir & "\*.*")
	If $search = -1 Then
		If $lang = "0407" Then
			$text = "Error - Es wurden keine Dateien/Verzeichnisse gefunden, die zu dem Suchmuster passen. Eventuell sind Zeichen enthalten, die nicht verarbeitet werden knnen oder das Verzeichnis enthlt keine Dateien." & Chr(13) & Chr(13) & $checkdir
		Else
			$text = "Error - No files/directories matching the search pattern. There may be characters that cannot be processed or the directory does not contain any files." & Chr(13) & Chr(13) & $checkdir
		EndIf
		logit($text)
		MsgBox(16, StringLeft(@ScriptName,StringLen(@ScriptName)-4), $text)
		Exit
	EndIf
	While 1
		$file = FileFindNextFile($search)
		If @error Then ExitLoop
		If StringInStr(FileGetAttrib($checkdir & "\" & $file),"D") <> 0 Then
			$sumd = $sumd + 1
			If $lang = "0407" Then
				logit("Verzeichnis: " & $sumd & " - " & $checkdir & "\" & $file)
			Else
				logit("Directory: " & $sumd & " - "  & $checkdir & "\" & $file)
			EndIf
			_ArrayAdd($path, $checkdir & "\" & $file)
		Else
			If StringRight($file,3) = "mp3" Or StringRight($file,3) = "wav" Then
				$sum = $sum + 1
			EndIf
			If $lang = "0407" Then
				logit("Datei: " & $file)
			Else
				logit("File: " & $file)
			EndIf
			FileChangeDir($checkdir)
			checkfile ($checkdir & "\" & $file)
		EndIf
	WEnd
	FileClose($search)
EndFunc










Func checkfile($file2)
	If StringRight($file2,3) = "mp3" Or StringRight($file2,3) = "wav" Then
		If StringRight($file2,8) <> " 432.mp3" Then
			If $lang = "0407" Then
				Do
					If ProcessExists("audacity.exe") Then
						ProcessClose("audacity.exe")
					EndIf
				Until convertfilede($file2) = 1
			Else
				Do
					If ProcessExists("audacity.exe") Then
						ProcessClose("audacity.exe")
					EndIf
				Until convertfileen($file2) = 1
			EndIf
		EndIf
	EndIf
EndFunc










Func convertfilede($file2)
	$FensterImporieren = 0
	TrayTip ( StringLeft(@ScriptName,StringLen(@ScriptName)-4), "Konvertiere: " & $file2 & Chr(13) & Chr(13) & "Zum unterbrechen " & $endkey & " drcken.", 30)
	$file2new = StringLeft($file2,StringLen($file2)-4) & " 432.mp3"
	If FileExists($file2new) = 1 Then FileDelete($file2new)

	If ProcessExists("audacity.exe") Then
		ProcessClose("audacity.exe")
	EndIf



	logit("   Konvertiere: " & $file2 & " - " & (FileGetSize($file2)/1024/1024) & " MB")
	Select
		Case FileExists(@ScriptDir & "\audacity.exe")
			$pid = Run(@ScriptDir & '\audacity.exe "' & $file2 & '"', @WorkingDir, @SW_SHOW)
		Case FileExists(@ProgramFilesDir & "\Audacity\audacity.exe")
			$pid = Run(@ProgramFilesDir & '\Audacity\audacity.exe "' & $file2 & '"', @WorkingDir, @SW_SHOW)
		Case FileExists("C:\Program Files (x86)\Audacity\audacity.exe")
			$pid = Run('C:\Program Files (x86)\Audacity\audacity.exe "' & $file2 & '"', @WorkingDir, @SW_SHOW)
		Case FileExists("C:\Program Files\Audacity\audacity.exe")
			$pid = Run('C:\Program Files\Audacity\audacity.exe "' & $file2 & '"', @WorkingDir, @SW_SHOW)
		Case Else
			$text = "ERROR: Audacity.exe nicht gefunden-> Abbruch"
			logit($text)
			MsgBox(16, StringLeft(@ScriptName,StringLen(@ScriptName)-4), $text)
			Exit(2)
	EndSelect
	ProcessSetPriority ( $pid, 3)

	$z = 0
	While WinExists ("[Title:Audacit;Class:wxWindowNR]", "" ) = 0 And WinExists ( "Automatische Wiederherstellung nach Absturz","Einige Projekte wurden nicht korrekt gespeichert" ) = 0 And WinExists ( "Importiere MP3-Dateien","" ) = 0 And $FensterImporieren = 0
		If $z > 39 Then
			logit('ERROR: Fenster "Audacity", "Panel" ist nach 20 Sekunden immer noch nicht vorhanden.')
			Return 0
		EndIf
		logit('    Warte darauf, das Audacity vollstndig geladen wurde.')
		$z2 = 0
		Do
			If WinExists ( "Importiere MP3-Dateien","" ) = 1 Then
				logit('    Fenster "Importiere MP3-Dateien","" ist bereits unerwartet vorhanden -> berspringe ...')
				$FensterImporieren = 1
			EndIf
			$z2 = $z2 + 1
			Sleep (10)
			If $FensterImporieren = 1 Then ExitLoop
		Until $z2 > 48
		$z = $z + 1
		If $FensterImporieren = 1 Then ExitLoop
	WEnd
	logit('   $z=' & $z)
	;If $z > 8 Then $delay=100
	logit('   Audacity wurde gestartet')

	$z = 0
	While WinExists ( "Automatische Wiederherstellung nach Absturz","Einige Projekte wurden nicht korrekt gespeichert" ) = 0 And WinExists ( "Importiere MP3-Dateien","" ) = 0 And $FensterImporieren = 0
		logit('    Warte darauf, dass das Fenster "Einige Projekte wurden nicht korrekt gespeichert" oder "Importiere MP3-Dateien" erscheint.')
		If $z > 39 Then
			logit('ERROR: Fenster "Automatische Wiederherstellung nach Absturz" und "Importiere MP3-Dateien" ist nach 20 Sekunden immer noch nicht vorhanden.')
			Return 0
		EndIf
		$z2 = 0
		Do
			If WinExists ( "Importiere MP3-Dateien","" ) = 1 Then
				logit('    Fenster "Importiere MP3-Dateien","" ist bereits unerwartet vorhanden -> berspringe ...')
				$FensterImporieren = 1
				ExitLoop
			EndIf
			$z2 = $z2 + 1
			Sleep (10)
			If $FensterImporieren = 1 Then ExitLoop
		Until $z2 > 48
		$z = $z + 1
		If $FensterImporieren = 1 Then ExitLoop
	WEnd

	If WinExists("Automatische Wiederherstellung nach Absturz","Einige Projekte wurden nicht korrekt gespeichert") Then
		logit('   Audacity wurde zuvor nicht sauber beendet, wird bereinigt.')
		While WinExists("Automatische Wiederherstellung nach Absturz","Einige Projekte wurden nicht korrekt gespeichert") = 1
			logit('    Fenster "Automatische Wiederherstellung nach Absturz - Einige Projekte wurden nicht korrekt gespeichert" existiert')
			logit('    Nchster Aufruf: ControlClick("Automatische Wiederherstellung nach Absturz","Einige Projekte wurden nicht korrekt gespeichert","Button3")')
			WinActivate("Automatische Wiederherstellung nach Absturz","Einige Projekte wurden nicht korrekt gespeichert")
			ControlClick("Automatische Wiederherstellung nach Absturz","Einige Projekte wurden nicht korrekt gespeichert","Button3")
			logit('    Nchster Aufruf: If WinExists ("Automatische Wiederherstellung nach Absturz","Einige Projekte wurden nicht korrekt gespeichert") = 0 Then ExitLoop')
			If WinExists ("Automatische Wiederherstellung nach Absturz","Einige Projekte wurden nicht korrekt gespeichert") = 0 Then ExitLoop
			logit('    Nchster Aufruf: WinWait("Verwerfen von Projekten besttigen","",10)')
			WinWait("Verwerfen von Projekten besttigen","",10)
			logit('    Nchster Aufruf: ControlClick("Verwerfen von Projekten besttigen","","Button1")')
			WinActivate("Verwerfen von Projekten besttigen","")
			ControlClick("Verwerfen von Projekten besttigen","","Button1")
		WEnd
	EndIf

	If WinExists ( "Importiere MP3-Dateien","" ) = 1 Then
		$FensterImporieren = 1
		logit('    Fenster "Importiere MP3-Dateien","" ist bereits unerwartet vorhanden --> berspringe ...')
	EndIf
	logit('   Importiere MP3-Dateien')
	If $FensterImporieren = 0 Then
		logit('    Nchster Aufruf: WinWait("Importiere MP3-Dateien","",5)')
		WinWait("Importiere MP3-Dateien","",5)
		If WinExists("Importiere MP3-Dateien","") Then
			logit('    Window "Importiere MP3-Dateien","" exist.')
		Else
			logit('ERROR: Window "Importiere MP3-Dateien","" existiert nicht.')
		EndIf
	EndIf
	logit('    Nchster Aufruf: WinWaitClose("Importiere MP3-Dateien", "")')
	WinWaitClose("Importiere MP3-Dateien", "")

	$suche = StringMid($file2,StringLen(@WorkingDir & "\")+1)
	$suche = StringLeft($suche,StringLen($suche)-4)
	WinSetTitle($suche,"","Audacity")

	; Change pitch
	logit('   Markiere alles zum Bearbeiten')
	logit('    Nchster Aufruf: ControlSend("Audacity","", "[CLASS:wxWindowNR; INSTANCE:70]", "^a^a^a^a")')
	WinActivate("Audacity")
	ControlSend("Audacity","", "[CLASS:wxWindowNR; INSTANCE:70]", "^a^a^a^a")
	logit('   Reduziere die Tonhhe')
	$z = 0
	While WinExists ( "Tonhhe ndern","" ) = 0
		If $z > 19 Then
			logit('ERROR: Fenster "Tonhhe ndern","" ist nach 10 Sekunden immer noch nicht vorhanden.')
			Return 0
		EndIf
		WinActivate("Audacity")
		ControlSend("Audacity","", "[CLASS:wxWindowNR; INSTANCE:70]", "!g")
		Sleep (500)
	WEnd

	logit('    Nchster Aufruf: ControlSetText("Tonhhe ndern","", "Edit6", "-1,818")')
	WinActivate("Tonhhe ndern")
	ControlSetText("Tonhhe ndern","", "Edit6", "-1,818")
	Sleep($delay)
	logit('    Nchster Aufruf: ControlClick("Tonhhe ndern","", "Button8")')
	WinActivate("Tonhhe ndern")
	ControlClick("Tonhhe ndern","", "Button8")
	logit('    Nchster Aufruf: WinWait("Tonhhe", "Wende Tonhhe",10)')
	WinWait("Tonhhe", "Wende Tonhhe",10)
	If WinExists("Tonhhe", "Wende Tonhhe") <> 1 Then
		logit('ERROR: Fenster "Tonhhe", "Wende Tonhhe" existiert nicht.')
		Return 0
	EndIf
	logit('    Nchster Aufruf: WinWaitClose("Tonhhe", "Wende Tonhhe")')
	WinWaitClose("Tonhhe", "Wende Tonhhe")

	; Export audio
	logit('   Audio exportieren')
	logit('    Nchster Aufruf: ControlSend("Audacity","", "[CLASS:wxWindowNR; INSTANCE:70]", "!f")')
	While WinExists ( "Audio exportieren","" ) = 0
		If $z > 19 Then
			logit('ERROR: Fenster "Audio exportieren","" ist nach 10 Sekunden immer noch nicht vorhanden.')
			Return 0
		EndIf
		WinActivate("Audacity")
		ControlSend("Audacity","", "[CLASS:wxWindowNR; INSTANCE:70]", "!f")
		Sleep (500)
	WEnd
	Sleep($delay*10)
	logit('    Nchster Aufruf: ControlSetText("Audio exportieren","", "Edit1", StringLeft($file2,StringLen($file2)-4) & " 432.mp3")')
	WinActivate("Audio exportieren")
	ControlSetText("Audio exportieren","", "Edit1", StringLeft($file2,StringLen($file2)-4) & " 432.mp3")
	Sleep($delay*10)
	ControlSetText("Audio exportieren","", "Edit1", StringLeft($file2,StringLen($file2)-4) & " 432.mp3")
	Sleep($delay*10)
	ControlSetText("Audio exportieren","", "Edit1", StringLeft($file2,StringLen($file2)-4) & " 432.mp3")
	logit('    Nchster Aufruf: ControlSend("Audio exportieren","", "Edit1", "{enter}")')
	WinActivate("Audio exportieren")
	ControlSend("Audio exportieren","", "Edit1", "{enter}")
	logit('    Nchster Aufruf: WinWait("Tag-Metadaten bearbeiten","Verwenden Sie zum Navigieren in den Feldern die Pfeiltasten (oder die Eingabetaste nach der Bearbeitung).")')
	WinWait("Tag-Metadaten bearbeiten","Verwenden Sie zum Navigieren in den Feldern die Pfeiltasten (oder die Eingabetaste nach der Bearbeitung).", 10)
	If WinExists("Tag-Metadaten bearbeiten","Verwenden Sie zum Navigieren in den Feldern die Pfeiltasten (oder die Eingabetaste nach der Bearbeitung).") <> 1 Then
		logit('ERROR: Fenster "Tag-Metadaten bearbeiten","Verwenden Sie zum Navigieren in den Feldern die Pfeiltasten (oder die Eingabetaste nach der Bearbeitung)." existiert nicht.')
		Return 0
	EndIf
	logit('    Nchster Aufruf: Send("{tab 13}432 Hz")')
	WinActivate("Tag-Metadaten bearbeiten","Verwenden Sie zum Navigieren in den Feldern die Pfeiltasten (oder die Eingabetaste nach der Bearbeitung).")
	Send("{tab 13}432 Hz")
	Sleep($delay*10)
	While WinExists("Tag-Metadaten bearbeiten","Verwenden Sie zum Navigieren in den Feldern die Pfeiltasten (oder die Eingabetaste nach der Bearbeitung).")
		logit('    Nchster Aufruf: ControlClick("Tag-Metadaten bearbeiten","Verwenden Sie zum Navigieren in den Feldern die Pfeiltasten (oder die Eingabetaste nach der Bearbeitung).", "Button11")')
		WinActivate("Tag-Metadaten bearbeiten","Verwenden Sie zum Navigieren in den Feldern die Pfeiltasten (oder die Eingabetaste nach der Bearbeitung).")
		ControlClick("Tag-Metadaten bearbeiten","Verwenden Sie zum Navigieren in den Feldern die Pfeiltasten (oder die Eingabetaste nach der Bearbeitung).", "Button11")
		Sleep(10)
	WEnd
	$suche = StringMid($file2,StringLen(@WorkingDir & "\")+1)
	$suche = StringLeft($suche,StringLen($suche)-4)
	logit('    Nchster Aufruf: WinWait($suche)')
	WinWait($suche, "", 20)
	If WinExists($suche, "") <> 1 Then
		logit('ERROR: Fenster $suche, "" existiert nicht, berprfe, ob Datei vorhanden ist.')
		If FileExists($file2) = 0 Then Return 0
		checkfilelog(StringLeft($file2,StringLen($file2)-4) & " 432.mp3")
	EndIf
	logit('    Nchster Aufruf: WinWaitClose($suche)')
	WinActivate($suche)
	WinWaitClose($suche)

	logit('   Adacity wird geschlossen')
	Do
		WinActivate("Audacity")
		logit('    Nchster Aufruf: ControlSend("Audacity","", "[CLASS:wxWindowNR; INSTANCE:70]", "^q")')
		ControlSend("Audacity","", "[CLASS:wxWindowNR; INSTANCE:70]", "^q")
		logit('    Nchster Aufruf: Until WinWait("nderungen speichern","",1) <> 0')
	Until WinWait("nderungen speichern","",1) <> 0
	If StringInStr(ControlGetText("nderungen speichern","", "Button2") , "No") <> 0 Or StringInStr(ControlGetText("nderungen speichern","", "Button2") , "Nein") <> 0 Then
		logit('    Nchster Aufruf: ControlClick("nderungen speichern","", "Button2")')
		WinActivate("nderungen speichern")
		ControlClick("nderungen speichern","", "Button2")
	Else
		logit('    Nchster Aufruf: ControlClick("nderungen speichern","", "Button3")')
		WinActivate("nderungen speichern")
		ControlClick("nderungen speichern","", "Button3")
	EndIf

	While ProcessExists("audacity.exe")
		Sleep(100)
	WEnd

	If FileExists($file2new) = 1 Then
		FileDelete($file2)
	EndIf
	Return 1
EndFunc










Func convertfileen($file2)
	$FensterImporieren = 0
	TrayTip ( StringLeft(@ScriptName,StringLen(@ScriptName)-4), "Converting: " & $file2 & Chr(13) & Chr(13) & "Press " & $endkey & " to abort.", 30)
	$file2new = StringLeft($file2,StringLen($file2)-4) & " 432.mp3"
	If FileExists($file2new) = 1 Then FileDelete($file2new)

	If ProcessExists("audacity.exe") Then
		ProcessClose("audacity.exe")
	EndIf


	logit("   convert: " & $file2 & " - " & (FileGetSize($file)/1024/1024) & " MB")
	Select
		Case FileExists(@ScriptDir & "\audacity.exe")
			$pid = Run(@ScriptDir & '\audacity.exe "' & $file2 & '"', @WorkingDir, @SW_SHOW)
		Case FileExists(@ProgramFilesDir & "\Audacity\audacity.exe")
			$pid = Run(@ProgramFilesDir & '\Audacity\audacity.exe "' & $file2 & '"', @WorkingDir, @SW_SHOW)
		Case FileExists("C:\Program Files (x86)\Audacity\audacity.exe")
			$pid = Run('C:\Program Files (x86)\Audacity\audacity.exe "' & $file2 & '"', @WorkingDir, @SW_SHOW)
		Case FileExists("C:\Program Files\Audacity\audacity.exe")
			$pid = Run('C:\Program Files\Audacity\audacity.exe "' & $file2 & '"', @WorkingDir, @SW_SHOW)
		Case Else
			$text = "Error: Audacity.exe not found-> abort"
			logit($text)
			MsgBox(16, StringLeft(@ScriptName,StringLen(@ScriptName)-4), $text)
			Exit(2)
	EndSelect
	ProcessSetPriority ( $pid, 3)

	$z = 0
	While WinExists ("[Title:Audacit;Class:wxWindowNR]", "" ) = 0 And WinExists ( "Automatic Crash Recovery","Some projects were not saved properly the last time Audacity was run." ) = 0 And WinExists ( "Importing","" ) = 0 And $FensterImporieren = 0
		If $z > 39 Then
			logit('ERROR: Window "Audacity", "Panel" is still missing after 20 seconds.')
			Return 0
		EndIf
		logit('    Wait for Audacity to be fully loaded.')
		$z2 = 0
		Do
			If WinExists ( "Importing","" ) = 1 Then
				logit('    Window "Importing","" already exists unexpectedly -> Skip ...')
				$FensterImporieren = 1
			EndIf
			$z2 = $z2 + 1
			Sleep (10)
			If $FensterImporieren = 1 Then ExitLoop
		Until $z2 > 48
		$z = $z + 1
		If $FensterImporieren = 1 Then ExitLoop
	WEnd
	logit('   $z=' & $z)
	;If $z > 8 Then $delay=100
	logit('   Audacity has been started')

	$z = 0
	While WinExists ( "Automatic Crash Recovery","Some projects were not saved properly the last time Audacity was run." ) = 0 And WinExists ( "Importing","" ) = 0 And $FensterImporieren = 0
		If $z > 39 Then
			logit('ERROR: Window "Automatic Crash Recovery" und "Importing" is still missing after 20 seconds.')
			Return 0
		EndIf
		$z2 = 0
		Do
			If WinExists ( "Importing","" ) = 1 Then
				logit('    Window "Importing","" already exists unexpectedly -> Skip ...')
				$FensterImporieren = 1
			EndIf
			$z2 = $z2 + 1
			Sleep (10)
			If $FensterImporieren = 1 Then ExitLoop
		Until $z2 > 48
		$z = $z + 1
		If $FensterImporieren = 1 Then ExitLoop
	WEnd

	If WinExists("Automatic Crash Recovery","Some projects were not saved properly the last time Audacity was run.") Then
		logit('   Audacity was not closed clean before, will be cleaned up now.')
		While WinExists("Automatic Crash Recovery","Some projects were not saved properly the last time Audacity was run.") = 1
			logit('    Window "Automatic Crash Recovery","Some projects were not saved properly the last time Audacity was run." exist.')
			logit('    next step: ControlClick("Automatic Crash Recovery","Some projects were not saved properly the last time Audacity was run.","Button3")')
			WinActivate("Automatic Crash Recovery","Some projects were not saved properly the last time Audacity was run.")
			ControlClick("Automatic Crash Recovery","Some projects were not saved properly the last time Audacity was run.","Button3")
			logit('    next step: If WinExists ("Automatic Crash Recovery","Some projects were not saved properly the last time Audacity was run.") = 0 Then ExitLoop')
			If WinExists ("Automatic Crash Recovery","Some projects were not saved properly the last time Audacity was run.") = 0 Then ExitLoop
			logit('    next step: WinWait("Confirm Discard Projects","",10)')
			WinWait("Confirm Discard Projects","",10)
			logit('    next step: ControlClick("Confirm Discard Projects","","Button1")')
			WinActivate("Confirm Discard Projects","")
			ControlClick("Confirm Discard Projects","","Button1")
		WEnd
	EndIf

	If WinExists ( "Importing","" ) = 1 Then
		$FensterImporieren = 1
		logit('    Window "Importing","" already exists unexpectedly --> Skip ...')
	EndIf
	logit('   import MP3-File')
	If $FensterImporieren = 0 Then
		logit('    next step: WinWait("Importing")')
		WinWait("Importing","",5)
		If WinExists("Importing","") Then
			logit('    Window "Importing","" exist.')
		Else
			logit('ERROR: Window "Importing","" does not exist.')
		EndIf
	EndIf
	logit('    next step: WinWaitClose("Importing")')
	WinWaitClose("Importing")

	$suche = StringMid($file2,StringLen(@WorkingDir & "\")+1)
	$suche = StringLeft($suche,StringLen($suche)-4)
	WinSetTitle($suche,"","Audacity")

	logit('   select all to edit')
	logit('    next step: ControlSend("Audacity","", "[CLASS:wxWindowNR; INSTANCE:70]", "^a^a^a^a")')
	logit('   reduce the pitch')
	WinActivate("Audacity")
	ControlSend("Audacity","", "[CLASS:wxWindowNR; INSTANCE:70]", "^a^a^a^a")
	$z = 0
	While WinExists ( "Change Pitch","" ) = 0
		If $z > 19 Then
			logit('ERROR: Window "Change Pitch","" does not exist until 10 seconds.')
			Return 0
		EndIf
		WinActivate("Audacity")
		ControlSend("Audacity","", "[CLASS:wxWindowNR; INSTANCE:70]", "!g")
		Sleep (500)
	WEnd

	logit('    next step: ControlSetText("Change Pitch","", "Edit6", "-1.818")')
	WinActivate("Change Pitch","")
	ControlSetText("Change Pitch","", "Edit6", "-1.818")
	logit('    next step: ControlClick("Change Pitch","", "Button8")')
	WinActivate("Change Pitch","")
	ControlClick("Change Pitch","", "Button8")
	logit('    next step: Until WinExists ("Change Pitch","Applying Change Pitch") Or WinExists ("High Quality Pitch Change","Applying High Quality Pitch Change")')
	Do
		Sleep(20)
	Until WinExists ("Change Pitch","Applying Change Pitch") Or WinExists ("High Quality Pitch Change","Applying High Quality Pitch Change")
	logit('    next step: WinWaitClose("High Quality Pitch Change", "Applying High Quality Pitch Change")')
	WinWaitClose("High Quality Pitch Change", "Applying High Quality Pitch Change")
	logit('    next step: WinWaitClose("Change Pitch", "Applying Change Pitch")')
	WinWaitClose("Change Pitch", "Applying Change Pitch")
	; Export audio
	logit('   export audio')
	logit('    next step: ControlSend("Audacity","", "", "!f")')
	While WinExists ( "Export Audio", "" ) = 0
		If $z > 19 Then
			logit('ERROR: Window "Export Audio","" does not exist until 10 seconds.')
			Return 0
		EndIf
		WinActivate("Audacity")
		ControlSend("Audacity","", "[CLASS:wxWindowNR; INSTANCE:70]", "!f")
		Sleep (500)
	WEnd
	Sleep($delay*10)
	logit('    next step: ControlSetText("Export Audio","", "Edit1", StringLeft($file2,StringLen($file2)-4) & " 432.mp3")')
	WinActivate("Export Audio","")
	ControlSetText("Export Audio","", "Edit1", StringLeft($file2,StringLen($file2)-4) & " 432.mp3")
	Sleep($delay*10)
	ControlSetText("Export Audio","", "Edit1", StringLeft($file2,StringLen($file2)-4) & " 432.mp3")
	Sleep($delay*10)
	ControlSetText("Export Audio","", "Edit1", StringLeft($file2,StringLen($file2)-4) & " 432.mp3")
	Sleep($delay*10)
	logit('    next step: ControlSend("Export Audio","", "Edit1", "{enter}")')
	WinActivate("Export Audio","")
	ControlSend("Export Audio","", "Edit1", "{enter}")
	logit('    next step: WinWait("Edit Metadata Tags","Use arrow keys (or ENTER key after editing) to navigate fields.")')
	WinWait("Edit Metadata Tags","Use arrow keys (or ENTER key after editing) to navigate fields.", 10)
	If WinExists("Edit Metadata Tags","Use arrow keys (or ENTER key after editing) to navigate fields.") <> 1 Then
		logit('ERROR: Window "Edit Metadata Tags","Use arrow keys (or ENTER key after editing) to navigate fields." does not exist.')
		Return 0
	EndIf
	logit('    next step: Send("{tab 13}432 Hz")')
	WinActivate("Edit Metadata Tags","Use arrow keys (or ENTER key after editing) to navigate fields.")
	Send("{tab 13}432 Hz")
	Sleep($delay*10)
	While WinExists("Edit Metadata Tags","Use arrow keys (or ENTER key after editing) to navigate fields.")
		logit('    next step: ControlClick("Edit Metadata Tags","Use arrow keys (or ENTER key after editing) to navigate fields.", "Button11")')
		WinActivate("Edit Metadata Tags","Use arrow keys (or ENTER key after editing) to navigate fields.")
		ControlClick("Edit Metadata Tags","Use arrow keys (or ENTER key after editing) to navigate fields.", "Button11")
		Sleep(500)
	WEnd
	$suche = StringMid($file2,StringLen(@WorkingDir & "\")+1)
	$suche = StringLeft($suche,StringLen($suche)-4)
	logit('    next step: WinWait($suche)')
	WinWait($suche, "", 20)
	If WinExists($suche, "") <> 1 Then
		logit('ERROR: Window $suche, "" does not exist.')
		If FileExists($file2) = 0 Then Return 0
		checkfilelog(StringLeft($file2,StringLen($file2)-4) & " 432.mp3")
	EndIf
	logit('    next step: WinWaitClose($suche)')
	WinWaitClose($suche)

	logit('   Audacity is closed')
	Do
		logit('    next step: ControlSend("Audacity","", "[CLASS:wxWindowNR; INSTANCE:70]", "^q")')
		WinActivate("Audacity")
		ControlSend("Audacity","", "[CLASS:wxWindowNR; INSTANCE:70]", "^q")
		logit('    next step: Until WinWait("Save changes","",1) <> 0')
	Until WinWait("Save changes","",1) <> 0
	If StringInStr(ControlGetText("Save changes","", "Button2") , "No") <> 0 Or StringInStr(ControlGetText("Save changes","", "Button2") , "Nein") <> 0 Then
		logit('    next step: ControlClick("Save changes","", "Button2")')
		WinActivate("Save changes","")
		ControlClick("Save changes","", "Button2")
	Else
		logit('    next step: ControlClick("Save changes","", "Button3")')
		WinActivate("Save changes","")
		ControlClick("Save changes","", "Button3")
	EndIf
	While ProcessExists("audacity.exe")
		Sleep(100)
	WEnd

	If FileExists($file2new) = 1 Then
		FileDelete($file2)
	EndIf
	Return 1
EndFunc










Func end()
	If ProcessExists("audacity.exe") Then
		ProcessClose("audacity.exe")
	EndIf
	If $lang = "0407" Then
		logit("Unterbrochen durch den Benutzer." & $sumd - $open & " Verzeichnise wurden durchsucht."& $sum & " Dateien wurden berprft / konvertiert. " & $open & " Verzeichnisse wurden nicht berprft.")
		If FileExists(@TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-4) & " check.log") = 1 Then Run('notepad.exe "' & @TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-4) & ' check.log"', @WorkingDir)
		Sleep($delay*100)
		MsgBox (48, StringLeft(@ScriptName,StringLen(@ScriptName)-4),"Die Konvertierung nach 432 Hz wurde unterbrochen." & @CR & @CR & $sumd & " Verzeichnise wurden durchsucht. "& $sum & " Dateien wurden berprft / konvertiert.")
	Else
		logit("Abort by User. " & $sumd & " directorys have been scanned, " & $sum & " files have been checked / converted. " & $open & " Directories were not scanned.")
		If FileExists(@TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-4) & " check.log") = 1 Then Run('notepad.exe "' & @TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-4) & ' check.log"', @WorkingDir)
		Sleep($delay*100)
		MsgBox (48, StringLeft(@ScriptName,StringLen(@ScriptName)-4),"The conversion to 432 Hz was aborted." & @CR & @CR & $sumd & " directorys have been scanned, " & $sum & " files have been checked / converted.")
	EndIf
	Exit
EndFunc










Func logit($text)
	While ProcessExists("EliteDangerous64.exe")
		Sleep(1000)
	WEnd
	If $trace = 1 Or StringLeft($text, 4) <> "    " Then
		If $trace = 2 Then
			$cpu = StringRight("0000" & Processor_Usage(),4)
			$text = @YEAR & "." & @MON & "." & @MDAY & " " & @HOUR & ":" & @MIN & ":" & @SEC & " - " & $sum & " - " & $cpu & " - " & $text
		Else
			$text = @YEAR & "." & @MON & "." & @MDAY & " " & @HOUR & ":" & @MIN & ":" & @SEC & " - " & $sum & " - " & $text
		EndIf
		ConsoleWrite($text & @CRLF)
		FileWriteLine(@TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-3) & "log", $text)
	EndIf
EndFunc










Func checkfilelog($text)
	If FileExists(@TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-4) & " check.log") = 0 Then
		If $lang = "0407" Then
			FileWriteLine(@TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-4) & " check.log", StringLeft(@ScriptName,StringLen(@ScriptName)-4))
			FileWriteLine(@TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-4) & " check.log", "")
			FileWriteLine(@TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-4) & " check.log", "Es ist ein unerwartetes Verhalten beim Konvertieren aufgetreten.")
			FileWriteLine(@TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-4) & " check.log", "Bitte berprfen Sie folgende Dateien, ob diese Korrekt umgewandelt worden sind:")
			FileWriteLine(@TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-4) & " check.log", "")
		Else
			FileWriteLine(@TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-4) & " check.log", StringLeft(@ScriptName,StringLen(@ScriptName)-4))
			FileWriteLine(@TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-4) & " check.log", "")
			FileWriteLine(@TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-4) & " check.log", "An unexpected behavior occurred during conversion.")
			FileWriteLine(@TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-4) & " check.log", "Please check the following files to make sure they have been converted correctly:")
			FileWriteLine(@TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-4) & " check.log", "")
		EndIf
	EndIf
	FileWriteLine(@TempDir & "\" & StringLeft(@ScriptName,StringLen(@ScriptName)-4) & " check.log", $text)
	If $lang = "0407" Then
		logit('ERROR: Datei "' & $text & '" vorhanden ist. Bitte berprfen Sie, ob das Ergebniss stimmig ist!')
	Else
		logit('ERROR: File "' & $text & '" exist. Please check if the result is correct!')
	EndIf
EndFunc










Func trace()
	$a = 0
	While $CmdLine[0] > $a
		$a = $a +1
		If StringMid($CmdLine[$a], 2) = "trace" Then $trace = 1
	WEnd
	If IniRead(StringLeft(@ScriptName,StringLen(@ScriptName)-3) & "ini", "Global", "trace", "0") = "1" Or IniRead(StringLeft(@ScriptName,StringLen(@ScriptName)-3) & "ini", "Global", "trace", "0") = "2" Or @Compiled = 0 Then
		$trace = 1
		$endkey = "`Pause`"
	EndIf
	If $trace = 1 And IniRead(StringLeft(@ScriptName,StringLen(@ScriptName)-3) & "ini", "Global", "trace", "0") = "2" Or @Compiled =  0 Then
		$tracedir = IniRead(StringLeft(@ScriptName,StringLen(@ScriptName)-3) & "ini", "Global", "Tracedir", "C:\download\ABBA")
		$tracedir = IniRead(StringLeft(@ScriptName,StringLen(@ScriptName)-3) & "ini", "Global", "Tracedir", "C:\Users\MWagner\Documents\MP3\EAV\EAV - Alles ist erlaubt (2018)")
		logit("$tracedir=" & $tracedir)
	EndIf

	If $trace = 1 Then
		FileDelete(@ScriptDir & "\DebugInfo.txt")
		$lang23 = RegRead("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Nls\Language", "InstallLanguage")
		IniWrite(@ScriptDir & "\DebugInfo.txt", "Debug", "Language", $lang23)
		$path2 = EnvGet("PATH")
		IniWrite(@ScriptDir & "\DebugInfo.txt", "Debug", "Path", $path2)
		IniWrite(@ScriptDir & "\DebugInfo.txt", "Debug", "OSVersion", @OSVersion)
		IniWrite(@ScriptDir & "\DebugInfo.txt", "Debug", "OSArch", @OSArch)
		IniWrite(@ScriptDir & "\DebugInfo.txt", "Debug", "OSLang", @OSLang)
		IniWrite(@ScriptDir & "\DebugInfo.txt", "Debug", "OSBuild", @OSBuild)
		IniWrite(@ScriptDir & "\DebugInfo.txt", "Debug", "OSServicePack", @OSServicePack)
		IniWrite(@ScriptDir & "\DebugInfo.txt", "Debug", "OSType", @OSType)

		$debug = FileOpen(@ScriptDir & "\DebugInfo.txt", 1)
		If $debug = -1 Then
			MsgBox(0, "Error", "File DebugInfo.txt can not open for writeing.")
			Return(1603)
		EndIf

			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall" )
			For $i= 1 to 10000000
				$var = RegEnumKey("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall", $i)
				If @error <> 0 then ExitLoop
				$displayname = RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\" & $var,"DisplayName")
				$version = RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\" & $var,"DisplayVersion")
				$quietuninstallstring = RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\" & $var,"QuietUninstallString")
				$uninstallstring = RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\" & $var,"UninstallString")
				FileWriteLine ($debug, $var & " - DisplayName:          " & $displayname)
				FileWriteLine ($debug, $var & " - DisplayVersion:       " & $version)
				FileWriteLine ($debug, $var & " - QuietUninstallString: " & $quietuninstallstring)
				FileWriteLine ($debug, $var & " - UninstallString:      " & $uninstallstring)
			Next

			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall" )
			For $i= 1 to 10000000
				$var = RegEnumKey("HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall", $i)
				If @error <> 0 then ExitLoop
				$displayname = RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\" & $var,"DisplayName")
				$version = RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\" & $var,"DisplayVersion")
				$quietuninstallstring = RegRead("HKEY_LOCAL_MACHINE\Wow6432Node\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\" & $var,"QuietUninstallString")
				$uninstallstring = RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\" & $var,"UninstallString")
				FileWriteLine ($debug, $var & " - DisplayName:          " & $displayname)
				FileWriteLine ($debug, $var & " - DisplayVersion:       " & $version)
				FileWriteLine ($debug, $var & " - QuietUninstallString: " & $quietuninstallstring)
				FileWriteLine ($debug, $var & " - UninstallString:      " & $uninstallstring)
			Next

			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "HKEY_CURRENT_USER\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall" )
			For $i= 1 to 10000000
				$var = RegEnumKey("HKEY_CURRENT_USER\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall", $i)
				If @error <> 0 then ExitLoop
				$displayname = RegRead("HKEY_CURRENT_USER\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\" & $var,"DisplayName")
				$version = RegRead("HKEY_CURRENT_USER\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\" & $var,"DisplayVersion")
				$quietuninstallstring = RegRead("HKEY_CURRENT_USER\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\" & $var,"QuietUninstallString")
				$uninstallstring = RegRead("HKEY_CURRENT_USER\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\" & $var,"UninstallString")
				FileWriteLine ($debug, $var & " - DisplayName:          " & $displayname)
				FileWriteLine ($debug, $var & " - DisplayVersion:       " & $version)
				FileWriteLine ($debug, $var & " - QuietUninstallString: " & $quietuninstallstring)
				FileWriteLine ($debug, $var & " - UninstallString:      " & $uninstallstring)
			Next

			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\RunOnce" )
			For $i= 1 to 10000000
				$var = RegEnumVal("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\RunOnce", $i)
				if @error <> 0 Then ExitLoop
				FileWriteLine ($debug, $i & " - Name: " & $var & " : " & RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\RunOnce", $var))
			Next

			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\RunOnce" )
			For $i= 1 to 10000000
				$var = RegEnumVal("HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\RunOnce", $i)
				if @error <> 0 Then ExitLoop
				FileWriteLine ($debug, $i & " - Name: " & $var & " : " & RegRead("HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\RunOnce", $var))
			Next

			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Run" )
			For $i= 1 to 10000000
				$var = RegEnumVal("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Run", $i)
				if @error <> 0 Then ExitLoop
				FileWriteLine ($debug, $i & " - Name: " & $var & " : " & RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Run", $var))
			Next

			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\Run" )
			For $i= 1 to 10000000
				$var = RegEnumVal("HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\Run", $i)
				if @error <> 0 Then ExitLoop
				FileWriteLine ($debug, $i & " - Name: " & $var & " : " & RegRead("HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\Run", $var))
			Next

			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, @StartupDir )
			$search = FileFindFirstFile(@StartupDir & "\*.*")
			If $search <> -1 Then
				While 1
					$file3 = FileFindNextFile($search)
					If @error Then ExitLoop
					If StringRight($file3,4) = ".lnk" Then
						FileWriteLine ($debug, "Name: " & $file3 & " Destiantion: " & getshortcut(@StartupDir & "\" & $file3))
					Else
						FileWriteLine ($debug, "Name: " & $file3)
					EndIf
				WEnd
			EndIf
			FileClose($search)


			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, @StartupCommonDir )
			$search = FileFindFirstFile(@StartupCommonDir & "\*.*")
			If $search <> -1 Then
				While 1
					$file3 = FileFindNextFile($search)
					If @error Then ExitLoop
					If StringRight($file3,4) = ".lnk" Then
						FileWriteLine ($debug, "Name: " & $file3 & " Destiantion: " & getshortcut(@StartupCommonDir & "\" & $file3))
					Else
						FileWriteLine ($debug, "Name: " & $file3)
					EndIf
				WEnd
			EndIf
			FileClose($search)

			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\services - sys" )
			For $i= 1 to 10000000
				$var = RegEnumKey("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\services", $i)
				If @error <> 0 Then ExitLoop
				If StringInStr(RegRead("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\services\" & $var, "ImagePath"), ".sys") > 0 Then
					FileWriteLine ($debug, $i & " - Name: " & $var & " DisplayName: " & RegRead("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\services\" & $var, "DisplayName"))
					FileWriteLine ($debug, $i & " - Name: " & $var & " ImagePath:   " & RegRead("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\services\" & $var, "ImagePath"))
					FileWriteLine ($debug, "")
				EndIf
			Next
			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\services <> sys" )
			For $i= 1 to 10000000
				$var = RegEnumKey("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\services", $i)
				If @error <> 0 Then ExitLoop
				If StringInStr(RegRead("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\services\" & $var, "ImagePath"), ".sys") = 0 Then
					FileWriteLine ($debug, $i & " - Name: " & $var & " DisplayName: " & RegRead("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\services\" & $var, "DisplayName"))
					FileWriteLine ($debug, $i & " - Name: " & $var & " ImagePath:   " & RegRead("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\services\" & $var, "ImagePath"))
					FileWriteLine ($debug, "")
				EndIf
			Next

			#comments-start
			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "" )

			Dim $Processors
			_ComputerGetProcessors($Processors)
			If @error Then
				$error = @error
				$extended = @extended
			EndIf

			For $i = 1 To $Processors[0][0] Step 1
				$text = $Processors[$i][0] & @CRLF & _
				"Address Width: " & $Processors[$i][1] & @CRLF & _
				"Architecture: " & $Processors[$i][2] & @CRLF & _
				"Availability: " & $Processors[$i][3] & @CRLF & _
				"Description: " & $Processors[$i][4] & @CRLF & _
				"Config Manager Error Code: " & $Processors[$i][5] & @CRLF & _
				"Config Manager User Config: " & $Processors[$i][6] & @CRLF & _
				"CPU Status: " & $Processors[$i][7] & @CRLF & _
				"Creation Class Name: " & $Processors[$i][8] & @CRLF & _
				"Current Clock Speed: " & $Processors[$i][9] & @CRLF & _
				"Current Voltage: " & $Processors[$i][10] & @CRLF & _
				"Data Width: " & $Processors[$i][11] & @CRLF & _
				"Device ID: " & $Processors[$i][12] & @CRLF & _
				"Error Cleared: " & $Processors[$i][13] & @CRLF & _
				"Error Description: " & $Processors[$i][14] & @CRLF & _
				"Ext Clock: " & $Processors[$i][15] & @CRLF & _
				"Family: " & $Processors[$i][16] & @CRLF & _
				"L2 Cache Size: " & $Processors[$i][17] & @CRLF & _
				"L2 Cache Speed: " & $Processors[$i][18] & @CRLF & _
				"Last Error Code: " & $Processors[$i][19] & @CRLF & _
				"Level: " & $Processors[$i][20] & @CRLF & _
				"Load Percentage: " & $Processors[$i][21] & @CRLF & _
				"Manufacturer: " & $Processors[$i][22] & @CRLF & _
				"Max Clock Speed: " & $Processors[$i][23] & @CRLF & _
				"Other Family Description: " & $Processors[$i][24] & @CRLF & _
				"PNP Device ID: " & $Processors[$i][25] & @CRLF & _
				"Power Management Capabilities: " & $Processors[$i][26] & @CRLF & _
				"Power Management Supported: " & $Processors[$i][27] & @CRLF & _
				"Processor ID: " & $Processors[$i][28] & @CRLF & _
				"Processor Type: " & $Processors[$i][29] & @CRLF & _
				"Revision: " & $Processors[$i][30] & @CRLF & _
				"Role: " & $Processors[$i][31] & @CRLF & _
				"Socket Designation: " & $Processors[$i][32] & @CRLF & _
				"Status: " & $Processors[$i][33] & @CRLF & _
				"Status Info: " & $Processors[$i][34] & @CRLF & _
				"Stepping: " & $Processors[$i][35] & @CRLF & _
				"System Creation Class Name: " & $Processors[$i][36] & @CRLF & _
				"System Name: " & $Processors[$i][37] & @CRLF & _
				"Unique ID: " & $Processors[$i][38] & @CRLF & _
				"Upgrade Method: " & $Processors[$i][39] & @CRLF & _
				"Version: " & $Processors[$i][40] & @CRLF & _
				"Voltage Caps: " & $Processors[$i][41]
				FileWriteLine ( $debug, $text )
			Next

			#comments-end

			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "" )
			FileWriteLine ( $debug, "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
			FileWriteLine ( $debug, "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
			FileWriteLine ( $debug, "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" )
			FileWriteLine ( $debug, "" )
		FileClose($debug)
		processtrace()
	EndIf
EndFunc

Func getshortcut($path3)
	$details = FileGetShortcut($path3)
	Return $details[0]
EndFunc


Func processtrace()
	$debug = FileOpen(@ScriptDir & "\DebugInfo.txt", 1)
	If $debug = -1 Then
		MsgBox(0, "Error", "File DebugInfo.txt can not open for writeing.")
		Return(1603)
	EndIf
	FileWriteLine ( $debug, "" )
	FileWriteLine ( $debug, "" )
	FileWriteLine ( $debug, "Processtrace ")
	$list = ProcessList()
	For $i = 1 To $list[0][0]
	  If $list[$i][0] <> "System" Then
		$text = $list[$i][0] & ": " & ProcessGetStatsdetail($list[$i][1])
	  EndIf
	  FileWriteLine($debug, $text)
	Next
	FileClose($debug)
EndFunc


Func ProcessGetStatsdetail($pid)
	$IO = ProcessGetStats($pid, 1)
	If IsArray ( $IO ) Then
		$return = $IO[1] & " " & $IO[2] & " " & $IO[3]
	Else
		$return = ""
	EndIf
	Return $return
EndFunc


Func Processor_Usage()
	Local $s_Text = ''
	Dim $Obj_WMIService = ObjGet('winmgmts:\\' & @ComputerName & '\root\cimv2');
	If (IsObj($Obj_WMIService)) And (Not @error) Then
		Dim $Col_Items = $Obj_WMIService.ExecQuery('SELECT * FROM Win32_PerfFormattedData_PerfOS_Processor')

		Local $Obj_Item
		For $Obj_Item In $Col_Items
			Local $s_Text = $Obj_Item.PercentProcessorTime & '%'
		Next

		Return String($s_Text)
	Else
		Return 0
	EndIf
EndFunc


Func _ComputerGetProcessors(ByRef $aProcessorInfo)
	$ERR_NO_INFO = "Array contains no information"
	$ERR_NOT_OBJ = "$colItems isnt an object"
	$wbemFlagReturnImmediately	= 0x10
	$wbemFlagForwardOnly		= 0x20

	Local $colItems, $objWMIService, $objItem
	Dim $aProcessorInfo[1][42], $i = 1

	$objWMIService = ObjGet("winmgmts:\\" & @ComputerName & "\root\CIMV2")
	$colItems = $objWMIService.ExecQuery("SELECT * FROM Win32_Processor", "WQL", $wbemFlagReturnImmediately + $wbemFlagForwardOnly)
	If @error Then
		Return
	Endif

	If IsObj($colItems) Then
		For $objItem In $colItems
			ReDim $aProcessorInfo[UBound($aProcessorInfo) + 1][42]
			$aProcessorInfo[$i][0]  = StringStripWS($objItem.Name, 1)
			$aProcessorInfo[$i][1]  = $objItem.AddressWidth
			$aProcessorInfo[$i][2]  = $objItem.Architecture
			$aProcessorInfo[$i][3]  = $objItem.Availability
			$aProcessorInfo[$i][4]  = $objItem.Description
			$aProcessorInfo[$i][5]  = $objItem.ConfigManagerErrorCode
			$aProcessorInfo[$i][6]  = $objItem.ConfigManagerUserConfig
			$aProcessorInfo[$i][7]  = $objItem.CpuStatus
			$aProcessorInfo[$i][8]  = $objItem.CreationClassName
			$aProcessorInfo[$i][9]  = $objItem.CurrentClockSpeed
			$aProcessorInfo[$i][10] = $objItem.CurrentVoltage
			$aProcessorInfo[$i][11] = $objItem.DataWidth
			$aProcessorInfo[$i][12] = $objItem.DeviceID
			$aProcessorInfo[$i][13] = $objItem.ErrorCleared
			$aProcessorInfo[$i][14] = $objItem.ErrorDescription
			$aProcessorInfo[$i][15] = $objItem.ExtClock
			$aProcessorInfo[$i][16] = $objItem.Family
			$aProcessorInfo[$i][17] = $objItem.L2CacheSize
			$aProcessorInfo[$i][18] = $objItem.L2CacheSpeed
			$aProcessorInfo[$i][19] = $objItem.LastErrorCode
			$aProcessorInfo[$i][20] = $objItem.Level
			$aProcessorInfo[$i][21] = $objItem.LoadPercentage
			$aProcessorInfo[$i][22] = $objItem.Manufacturer
			$aProcessorInfo[$i][23] = $objItem.MaxClockSpeed
			$aProcessorInfo[$i][24] = $objItem.OtherFamilyDescription
			$aProcessorInfo[$i][25] = $objItem.PNPDeviceID
			$aProcessorInfo[$i][26] = $objItem.PowerManagementCapabilities(0)
			$aProcessorInfo[$i][27] = $objItem.PowerManagementSupported
			$aProcessorInfo[$i][28] = $objItem.ProcessorId
			$aProcessorInfo[$i][29] = $objItem.ProcessorType
			$aProcessorInfo[$i][30] = $objItem.Revision
			$aProcessorInfo[$i][31] = $objItem.Role
			$aProcessorInfo[$i][32] = $objItem.SocketDesignation
			$aProcessorInfo[$i][33] = $objItem.Status
			$aProcessorInfo[$i][34] = $objItem.StatusInfo
			$aProcessorInfo[$i][35] = $objItem.Stepping
			$aProcessorInfo[$i][36] = $objItem.SystemCreationClassName
			$aProcessorInfo[$i][37] = $objItem.SystemName
			$aProcessorInfo[$i][38] = $objItem.UniqueId
			$aProcessorInfo[$i][39] = $objItem.UpgradeMethod
			$aProcessorInfo[$i][40] = $objItem.Version
			$aProcessorInfo[$i][41] = $objItem.VoltageCaps
			$i += 1
		Next
		$aProcessorInfo[0][0] = UBound($aProcessorInfo) - 1
		If $aProcessorInfo[0][0] < 1 Then
			SetError(1, 1, 0)
		EndIf
	Else
		SetError(1, 2, 0)
	EndIf
EndFunc
